(function() {
  var define = function(name, f) {
    return define[name] = f;
  };
  var pending = {};
  var require = function(name) {
    if(!require[name]) {
      if(pending[name]) throw 'Circular include';
      pending[name] = true;
      require[name] = new (define[name]);
      delete pending[name];
    }
    return require[name];
  };define('./app', (function exports() {
var exports = this;
var content, escapeXml, jot, unescapeXml;
jot = require('./view').jot;
jot.declareTag('c');
content = require('./content');
escapeXml = function(x) {
  x = x.replace(/&/g, '&amp;');
  x = x.replace(/>/g, '&gt;');
  return x = x.replace(/</g, '&lt;');
};
unescapeXml = function(x) {
  x = x.replace(/&amp;/g, '&');
  x = x.replace(/&gt;/g, '>');
  return x = x.replace(/&lt;/g, '<');
};
$(function() {
  $('body').append(jot.app(content));
  return $('.example').each(function() {
    var coffee, compile, error, output, setError;
    coffee = $(this).find('.coffee');
    output = $(this).find('.output');
    error = $(this).find('.error');
    setError = function(e) {
      if (e) {
        return error.show().text(e.toString()).position({
          right: 5,
          top: 5
        });
      } else {
        return error.hide();
      }
    };
    compile = function() {
      var cs, fn, js;
      cs = "->\n  " + (coffee.val().replace(/\n/g, '\n  '));
      try {
        js = CoffeeScript.compile(cs, {
          bare: true
        });
        fn = eval(js);
        output.text(jot.run(fn));
        coffee.attr('rows', cs.split('\n').length - 1);
        setError();
        output.height('');
        return output.height(Math.max(coffee.height(), output.height()));
      } catch (e) {
        setError(e);
        console.log('--------- error compiling cs');
        return console.log(cs);
      }
    };
    compile();
    return coffee.bind('keyup', compile);
  });
});
}));define('./content', (function exports() {
var exports = this;
exports.sections = {
  'Overview': function() {
    $("*Edit the CoffeeScript on the left. Markup updates on the right.*\n\nTags are JavaScript functions that produce markup elements.");
    example({
      cs: "a()"
    });
    $("Tags take arguments. String and number arguments become text nodes...");
    example({
      cs: "a 'hi'"
    });
    $("...object arguments become attributes...");
    example({
      cs: "a foo:3, bar:'envy'"
    });
    $("...node arguments become children...");
    example({
      cs: "a b c"
    });
    $("...array arguments are flattened and each array element is processed\nas an argument. ");
    example({
      cs: "a (b str for str in ['x', 'y', 'z'])"
    });
    $("Tags can be called with an arbitrary number of arguments.");
    return example({
      cs: "a\n  foo:'/flake'\n  b 'jot'\n  c 'tackle'\n    b {x} for x in [1..5]"
    });
  },
  'Text': function() {
    $("All text is escaped by default");
    example({
      cs: " a '<&>'"
    });
    $("To avoid escaping text, prefix the text with a backtick ");
    example({
      cs: " a '`<&>'"
    });
    $("For convenience in an HTML context, text that starts with a period '.' or \na hash mark '#' are treated as classes and \nid attributes, respectively, if the rest of the string constitutes a valid class or id. ");
    example({
      cs: "a '.navlink', '#toc', 'Table of contents'"
    });
    $("Markdown can be used anywhere, using the `$` function.");
    return example({
      cs: "$ \"\"\"\n  Shopping list\n  -------------\n  - milk\n  - eggs\n  - nunchucks\n  - vegetables\n    - carrots\n    - brocolli\n  - *soup*\n  \"\"\""
    });
  },
  'Mixins': function() {
    $("A function passed as an argument to a tag gets *mixed-in* to the resulting element.\nSome functions in scope like `attr`, `text` and `call` allow you to manipulate the\ncurrent element from within the mixin. \n\nAny top-level elements created in the mixin get added to the current tag.\n");
    example({
      cs: "a ->\n  \n  "
    });
    return $("Anonymous mixins are useful for doing arbitray local computations");
  },
  'Macros': function() {
    return example({
      cs: "data =\n  'Get it': '#download'\n  'Flaunt it': '#showoff'\n\nitem = (label, href) -> li a {href}, label \n\nol (item key, val for key, val of data)"
    });
  },
  'Templates': function() {
    $("A template is a string with inline code. They are usually encapsulated in a function.");
    $("define your own jotlets \n");
    codeblock("javascript: -> \n  script {type:'text/javascript'}, arguments...");
    example({
      cs: "nav = -> _ '.nav', arguments...\n\nnav '.gonuts', 'Go Nuts',\n  img src: 'images/gonuts.png'"
    });
    example({
      cs: "$ \"\"\"\n  Shopping list\n  -------------\n  - milk\n  - eggs\n  - nunchucks\n  - vegetables\n    - carrots\n    - brocolli\n  - *soup*\n  \"\"\""
    });
    $("This is a quick example:");
    $(" \nThere's nothing really to say about that.");
    example({
      description: 'Overview',
      cs: "a()\n\n\na b c 'gravy'\n\n\n\na foo: 3, bar: 'super'\n\n# underscore '_' is short for 'div'\n_ '#footer'\n\n# Javascript tags\njavascript cdata \"\"\"\n  (function() {\n    var foo = 3\n    return function(x){ return foo < 3 }\n  })()\n  \"\"\"\n\nnote 'You can use markdown!'\n$ \"\"\"\n  Party Mix\n  ---------\n  - Coldplay\n    - Yellow\n    - Fix you\n  - Tori Amos\n    - Winter\n    - Jupiter\n  \"\"\""
    });
    return $("This is more information.");
  }
};
}));define('./view', (function exports() {
var exports = this;
var jot;
var __slice = Array.prototype.slice;
exports.jot = jot = new Jot.HtmlContext;
jot.macro({
  id: function(title) {
    return title.toLowerCase().replace(/[ ]/g, '-');
  }
}, {
  navigation: function() {
    return nav(function() {
      var item;
      img('.logo', {
        src: 'documentation/images/logo_small.png'
      });
      item = function() {
        var content, id;
        id = arguments[0], content = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        return a.apply(null, [".item." + id, {
          href: '#'
        }].concat(__slice.call(content)));
      };
      item('toc', 'Table of Contents', function() {
        var title;
        return _('#toc', (function() {
          var _results;
          _results = [];
          for (title in this.sections) {
            _results.push(a({
              href: "#" + (id(title))
            }, title));
          }
          return _results;
        }).call(this));
      });
      return item('source', 'Annotated Source');
    });
  },
  introduction: function() {
    return $("Jot is a CoffeeScript/JavaScript DSL for markup templates.\n\nIt is written in CoffeeScript. So it runs everwhere JavaScript can run.\n\n");
  },
  sections: function() {
    var content, title, _ref, _results;
    _ref = this.sections;
    _results = [];
    for (title in _ref) {
      content = _ref[title];
      _results.push(_('.section', {
        id: id(title)
      }, h1(title), scope(content)));
    }
    return _results;
  },
  codeblock: function() {
    return pre.apply(null, ['.codeblock'].concat(__slice.call(arguments)));
  },
  editor: function() {
    return textarea.apply(null, ['.editor'].concat(__slice.call(arguments)));
  },
  example: function() {
    return _('.example', _('.headings', _('.coffeeheading', 'jot.coffee'), _('.outputheading', 'html')), editor('.coffee', this.cs), pre('.output', 'blah'), _('.error'), this.description ? _('.description', "Example: " + this.description) : void 0);
  },
  app: function() {
    return _('#app', navigation, introduction, sections);
  },
  index: function() {
    doctype(5);
    return html({
      lang: 'en'
    }, head(title('Jotjs - A JavaScript DSL for creating Markup')), css('documentation/css/screen.css'), javascript({
      src: 'browser/jot.js'
    }), javascript({
      src: 'documentation/vendor/jquery.js'
    }), javascript({
      src: 'documentation/vendor/coffee-script.js'
    }), javascript({
      src: 'documentation/js/app.js'
    }), body(app));
  }
});
}));  require('./app');
})();