exports.jot = jot = new Jot.HtmlContext

jot.macro 
  id: (title) -> title.toLowerCase().replace /[ ]/g, '-'  
, 
  navigation: ->
    nav ->
      img '.logo', src: 'documentation/images/logo_small.png'
      item = (id, content...) -> a ".item.#{id}", {href: '#'}, content...
      item 'toc', 'Table of Contents', ->
        _ '#toc', 
          for title of @sections
            a href: "##{id title}", title
            
      item 'source', 'Annotated Source'
  
  introduction: ->
    $ """
      Jot is a CoffeeScript/JavaScript DSL for markup templates.
      
      It is written in CoffeeScript. So it runs everwhere JavaScript can run.
      

      """

  sections: ->
    for title, content of @sections
      _ '.section', id: id title, 
        h1 title
        scope content
  
  codeblock: -> pre '.codeblock', arguments...

  
  editor: ->
    textarea '.editor', arguments...
  
  example: ->
    _ '.example',
      _ '.headings',
        _ '.coffeeheading', 'jot.coffee'
        _ '.outputheading', 'html'
      editor '.coffee', @cs
      pre '.output', 'blah'
      _ '.error'
      _ '.description', "Example: #{@description}" if @description

  app: ->
    _ '#app', # '.showgrid',
      navigation
      introduction
      sections
      
  index: ->
    doctype 5
    html
      lang: 'en'
      head \
        title 'Jotjs - A JavaScript DSL for creating Markup'
        css 'documentation/css/screen.css'
        javascript src: 'browser/jot.js'
        javascript src: 'documentation/vendor/jquery.js'
        javascript src: 'documentation/vendor/coffee-script.js'
        javascript src: 'documentation/js/app.js'
                  
      body app
      
      
      
    